/**********************************************************************************

	AUTHOR: Erlend Halsteinli
	CREATED: SPRING 2009 @ IET NTNU

	Class reconstructing codestream from several udp packets.

***********************************************************************************/

#ifndef PACKETBUFFER2CODESTREAM_H
#define PACKETBUFFER2CODESTREAM_H

#define codOffset 89
#define socOffset 44

#include "Socket2PacketBuffer.h"

using namespace std;

//Max bytes in codestream field: 625000 (250Mbit/s @ 50fps)
#define CODESTREAM_BUFFER_WIDTH 625000
#define CODESTREAM_BUFFER_LENGTH 2

struct RtpFixedHeader{
	int version, padding, csrCCount, marker, payloadType, ssrc;
	unsigned int sequenceNumber, timeStamp;
};

struct RtpPayloadHeader{
	unsigned short field, klvElement, fieldNumber; 
	unsigned int payloadOffset;
};

struct TvipsHack{
	short fifoIndex, bitsPresent, keyLength, subChannel;
};

class PacketBuffer2Codestream:public Thread{

public:
	PacketBuffer2Codestream(char** packetBuffer[],int** bytesInBuffer, enum INPUT_VIDEO_FORMAT videoFormat);
	//~PacketBuffer2CodeStream();
	void Execute();
	void GetCodestreamBuffer(char** codestreamBuffer[], int** bytesInBuffer);
	
private:
	void PrintPacketHeaders();
	void ParsePacketHeader(int packetNumber);
	int MarkerSearch(char * packetData, int packetSize, int targetMarker, bool rtpHeaderPresent);
	void ClaimFramesSingleChip();
	void ClaimFramesDualChip();
	void ReconstructSingleField(int *currentPayloadIndex, int *currentCodeStream);
	void SortPartition(int partitionNumber);

	char* updPayloadBuffer[PAYLOAD_BUFFER_LENGTH];
	int* bytesInUdpPayload;
	char* jpcBuffer[CODESTREAM_BUFFER_LENGTH];
	int bytesInJpcBuffer[CODESTREAM_BUFFER_LENGTH];
	char* chromaTempBuffer;
	int bytesInChromaBuffer;
	ofstream debugLog;
	HANDLE bufferMutexPartition0,bufferMutexPartition1,bufferMutexPartition2,bufferMutexPartition3;
	HANDLE packetBufferSemaphore, codestreamBufferSemaphore;
	HANDLE codestreamBuff0, codestreamBuff1;
	enum INPUT_VIDEO_FORMAT inputVideoFormat;	
	struct RtpFixedHeader rtpFixedHeader;
	struct RtpPayloadHeader rtpPayloadHeader;
	struct TvipsHack tvipsHack;
};

#endif