/**********************************************************************************

	AUTHOR: Erlend Halsteinli
	CREATED: SPRING 2009 @ IET NTNU

	JPEG2000 code stream source, inherits from kdu_compressed_source.

***********************************************************************************/

#ifndef COMPRESSEDMEMORYSOURCE_H
#define COMPRESSEDMEMORYSOURCE_H

#include <kdu_compressed.h>
#include <fstream>
#include <iostream>

class kduCompressedMemorySource:public kdu_compressed_source{

public:
	kduCompressedMemorySource();
	void init(const char *fname);
	void init();
	//void init(char** codestreamBuffer, int** bytesInBuffer);
	void update(char* codestreamData, unsigned int bytesInCodestreamData);
	int get_capabilities();
	int read(kdu_byte * buf, int num_bytes);
	bool seek(kdu_long offset);
	kdu_long get_pos();
	kdu_byte* access_memory(kdu_long & pos, kdu_byte * & lim);
	bool close();

	void saveBufferContentToFile();

private:
	unsigned int bytesInJpcBuffer, *bytesInJpcBufferP;
	kdu_byte *jpcBuffer;
	kdu_long currentOffset;
	int capabilities;



};

#endif