#ifndef YCC2RGBCPU_H
#define YCC2RGBCPU_H

#include <iostream>

//cPixelCount number of pixels in Cr/Cb component before upsampling
void Ycc2RgbCpu(unsigned char * yccBuffer, unsigned char * rgbBufferCpu, int cPixelCount){
		
	float yTemp, cbTemp, crTemp;
	float rTemp, gTemp, bTemp;


	for(int yccIdx=0; yccIdx<cPixelCount; yccIdx++){

		yTemp=(float)*(yccBuffer+4*yccIdx+0);
		cbTemp=(float)*(yccBuffer+4*yccIdx+1)-128;
		crTemp=(float)*(yccBuffer+4*yccIdx+3)-128;
		rTemp=1.371*crTemp;
		gTemp=0.336*cbTemp + 0.698*crTemp;
		bTemp=1.732*cbTemp;

		*(rgbBufferCpu+6*yccIdx+0) =(unsigned char)(yTemp + rTemp);
		*(rgbBufferCpu+6*yccIdx+1) =(unsigned char)(yTemp - gTemp);
		*(rgbBufferCpu+6*yccIdx+2) = (unsigned char)(yTemp + bTemp);

		yTemp=(float)*(yccBuffer+4*yccIdx+2);

		*(rgbBufferCpu+6*yccIdx+3) =(unsigned char)(yTemp + rTemp);
		*(rgbBufferCpu+6*yccIdx+4) =(unsigned char)(yTemp - gTemp);
		*(rgbBufferCpu+6*yccIdx+5) = (unsigned char)(yTemp + bTemp);
 }


}
#endif